// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	"github.com/oapi-codegen/runtime"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
	. "gitlab.com/commonground/nlx/fsc-nlx/controller/ports/registration/rest/api/models"
)

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// RegisterInwayWithBody request with any body
	RegisterInwayWithBody(ctx context.Context, groupId GroupID, inwayName string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	RegisterInway(ctx context.Context, groupId GroupID, inwayName string, body RegisterInwayJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// RegisterOutwayWithBody request with any body
	RegisterOutwayWithBody(ctx context.Context, groupId GroupID, outwayName string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	RegisterOutway(ctx context.Context, groupId GroupID, outwayName string, body RegisterOutwayJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetService request
	GetService(ctx context.Context, groupId GroupID, serviceName ServiceName, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetHealth request
	GetHealth(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) RegisterInwayWithBody(ctx context.Context, groupId GroupID, inwayName string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewRegisterInwayRequestWithBody(c.Server, groupId, inwayName, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) RegisterInway(ctx context.Context, groupId GroupID, inwayName string, body RegisterInwayJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewRegisterInwayRequest(c.Server, groupId, inwayName, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) RegisterOutwayWithBody(ctx context.Context, groupId GroupID, outwayName string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewRegisterOutwayRequestWithBody(c.Server, groupId, outwayName, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) RegisterOutway(ctx context.Context, groupId GroupID, outwayName string, body RegisterOutwayJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewRegisterOutwayRequest(c.Server, groupId, outwayName, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetService(ctx context.Context, groupId GroupID, serviceName ServiceName, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetServiceRequest(c.Server, groupId, serviceName)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetHealth(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetHealthRequest(c.Server)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewRegisterInwayRequest calls the generic RegisterInway builder with application/json body
func NewRegisterInwayRequest(server string, groupId GroupID, inwayName string, body RegisterInwayJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewRegisterInwayRequestWithBody(server, groupId, inwayName, "application/json", bodyReader)
}

// NewRegisterInwayRequestWithBody generates requests for RegisterInway with any type of body
func NewRegisterInwayRequestWithBody(server string, groupId GroupID, inwayName string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "group_id", runtime.ParamLocationPath, groupId)
	if err != nil {
		return nil, err
	}

	var pathParam1 string

	pathParam1, err = runtime.StyleParamWithLocation("simple", false, "inway_name", runtime.ParamLocationPath, inwayName)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/groups/%s/inways/%s", pathParam0, pathParam1)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("PUT", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewRegisterOutwayRequest calls the generic RegisterOutway builder with application/json body
func NewRegisterOutwayRequest(server string, groupId GroupID, outwayName string, body RegisterOutwayJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewRegisterOutwayRequestWithBody(server, groupId, outwayName, "application/json", bodyReader)
}

// NewRegisterOutwayRequestWithBody generates requests for RegisterOutway with any type of body
func NewRegisterOutwayRequestWithBody(server string, groupId GroupID, outwayName string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "group_id", runtime.ParamLocationPath, groupId)
	if err != nil {
		return nil, err
	}

	var pathParam1 string

	pathParam1, err = runtime.StyleParamWithLocation("simple", false, "outway_name", runtime.ParamLocationPath, outwayName)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/groups/%s/outways/%s", pathParam0, pathParam1)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("PUT", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewGetServiceRequest generates requests for GetService
func NewGetServiceRequest(server string, groupId GroupID, serviceName ServiceName) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "group_id", runtime.ParamLocationPath, groupId)
	if err != nil {
		return nil, err
	}

	var pathParam1 string

	pathParam1, err = runtime.StyleParamWithLocation("simple", false, "service_name", runtime.ParamLocationPath, serviceName)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/groups/%s/services/%s", pathParam0, pathParam1)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewGetHealthRequest generates requests for GetHealth
func NewGetHealthRequest(server string) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/health")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// RegisterInwayWithBodyWithResponse request with any body
	RegisterInwayWithBodyWithResponse(ctx context.Context, groupId GroupID, inwayName string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*RegisterInwayResponse, error)

	RegisterInwayWithResponse(ctx context.Context, groupId GroupID, inwayName string, body RegisterInwayJSONRequestBody, reqEditors ...RequestEditorFn) (*RegisterInwayResponse, error)

	// RegisterOutwayWithBodyWithResponse request with any body
	RegisterOutwayWithBodyWithResponse(ctx context.Context, groupId GroupID, outwayName string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*RegisterOutwayResponse, error)

	RegisterOutwayWithResponse(ctx context.Context, groupId GroupID, outwayName string, body RegisterOutwayJSONRequestBody, reqEditors ...RequestEditorFn) (*RegisterOutwayResponse, error)

	// GetServiceWithResponse request
	GetServiceWithResponse(ctx context.Context, groupId GroupID, serviceName ServiceName, reqEditors ...RequestEditorFn) (*GetServiceResponse, error)

	// GetHealthWithResponse request
	GetHealthWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetHealthResponse, error)
}

type RegisterInwayResponse struct {
	Body                      []byte
	HTTPResponse              *http.Response
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON404 *N404NotFound
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r RegisterInwayResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r RegisterInwayResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type RegisterOutwayResponse struct {
	Body                      []byte
	HTTPResponse              *http.Response
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON404 *N404NotFound
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r RegisterOutwayResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r RegisterOutwayResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetServiceResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *struct {
		Service Service `json:"service"`
	}
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON404 *N404NotFound
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r GetServiceResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetServiceResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetHealthResponse struct {
	Body         []byte
	HTTPResponse *http.Response
}

// Status returns HTTPResponse.Status
func (r GetHealthResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetHealthResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// RegisterInwayWithBodyWithResponse request with arbitrary body returning *RegisterInwayResponse
func (c *ClientWithResponses) RegisterInwayWithBodyWithResponse(ctx context.Context, groupId GroupID, inwayName string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*RegisterInwayResponse, error) {
	rsp, err := c.RegisterInwayWithBody(ctx, groupId, inwayName, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseRegisterInwayResponse(rsp)
}

func (c *ClientWithResponses) RegisterInwayWithResponse(ctx context.Context, groupId GroupID, inwayName string, body RegisterInwayJSONRequestBody, reqEditors ...RequestEditorFn) (*RegisterInwayResponse, error) {
	rsp, err := c.RegisterInway(ctx, groupId, inwayName, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseRegisterInwayResponse(rsp)
}

// RegisterOutwayWithBodyWithResponse request with arbitrary body returning *RegisterOutwayResponse
func (c *ClientWithResponses) RegisterOutwayWithBodyWithResponse(ctx context.Context, groupId GroupID, outwayName string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*RegisterOutwayResponse, error) {
	rsp, err := c.RegisterOutwayWithBody(ctx, groupId, outwayName, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseRegisterOutwayResponse(rsp)
}

func (c *ClientWithResponses) RegisterOutwayWithResponse(ctx context.Context, groupId GroupID, outwayName string, body RegisterOutwayJSONRequestBody, reqEditors ...RequestEditorFn) (*RegisterOutwayResponse, error) {
	rsp, err := c.RegisterOutway(ctx, groupId, outwayName, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseRegisterOutwayResponse(rsp)
}

// GetServiceWithResponse request returning *GetServiceResponse
func (c *ClientWithResponses) GetServiceWithResponse(ctx context.Context, groupId GroupID, serviceName ServiceName, reqEditors ...RequestEditorFn) (*GetServiceResponse, error) {
	rsp, err := c.GetService(ctx, groupId, serviceName, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetServiceResponse(rsp)
}

// GetHealthWithResponse request returning *GetHealthResponse
func (c *ClientWithResponses) GetHealthWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetHealthResponse, error) {
	rsp, err := c.GetHealth(ctx, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetHealthResponse(rsp)
}

// ParseRegisterInwayResponse parses an HTTP response from a RegisterInwayWithResponse call
func ParseRegisterInwayResponse(rsp *http.Response) (*RegisterInwayResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &RegisterInwayResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest N404NotFound
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ParseRegisterOutwayResponse parses an HTTP response from a RegisterOutwayWithResponse call
func ParseRegisterOutwayResponse(rsp *http.Response) (*RegisterOutwayResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &RegisterOutwayResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest N404NotFound
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ParseGetServiceResponse parses an HTTP response from a GetServiceWithResponse call
func ParseGetServiceResponse(rsp *http.Response) (*GetServiceResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetServiceResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest struct {
			Service Service `json:"service"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest N404NotFound
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ParseGetHealthResponse parses an HTTP response from a GetHealthWithResponse call
func ParseGetHealthResponse(rsp *http.Response) (*GetHealthResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetHealthResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Register an Inway
	// (PUT /v1/groups/{group_id}/inways/{inway_name})
	RegisterInway(w http.ResponseWriter, r *http.Request, groupId GroupID, inwayName string)
	// Register an Outway
	// (PUT /v1/groups/{group_id}/outways/{outway_name})
	RegisterOutway(w http.ResponseWriter, r *http.Request, groupId GroupID, outwayName string)
	// Get a service
	// (GET /v1/groups/{group_id}/services/{service_name})
	GetService(w http.ResponseWriter, r *http.Request, groupId GroupID, serviceName ServiceName)
	// health endpoint for the Controller Registration API
	// (GET /v1/health)
	GetHealth(w http.ResponseWriter, r *http.Request)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// Register an Inway
// (PUT /v1/groups/{group_id}/inways/{inway_name})
func (_ Unimplemented) RegisterInway(w http.ResponseWriter, r *http.Request, groupId GroupID, inwayName string) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Register an Outway
// (PUT /v1/groups/{group_id}/outways/{outway_name})
func (_ Unimplemented) RegisterOutway(w http.ResponseWriter, r *http.Request, groupId GroupID, outwayName string) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Get a service
// (GET /v1/groups/{group_id}/services/{service_name})
func (_ Unimplemented) GetService(w http.ResponseWriter, r *http.Request, groupId GroupID, serviceName ServiceName) {
	w.WriteHeader(http.StatusNotImplemented)
}

// health endpoint for the Controller Registration API
// (GET /v1/health)
func (_ Unimplemented) GetHealth(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// RegisterInway operation middleware
func (siw *ServerInterfaceWrapper) RegisterInway(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "group_id" -------------
	var groupId GroupID

	err = runtime.BindStyledParameterWithOptions("simple", "group_id", chi.URLParam(r, "group_id"), &groupId, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "group_id", Err: err})
		return
	}

	// ------------- Path parameter "inway_name" -------------
	var inwayName string

	err = runtime.BindStyledParameterWithOptions("simple", "inway_name", chi.URLParam(r, "inway_name"), &inwayName, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "inway_name", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.RegisterInway(w, r, groupId, inwayName)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// RegisterOutway operation middleware
func (siw *ServerInterfaceWrapper) RegisterOutway(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "group_id" -------------
	var groupId GroupID

	err = runtime.BindStyledParameterWithOptions("simple", "group_id", chi.URLParam(r, "group_id"), &groupId, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "group_id", Err: err})
		return
	}

	// ------------- Path parameter "outway_name" -------------
	var outwayName string

	err = runtime.BindStyledParameterWithOptions("simple", "outway_name", chi.URLParam(r, "outway_name"), &outwayName, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "outway_name", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.RegisterOutway(w, r, groupId, outwayName)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetService operation middleware
func (siw *ServerInterfaceWrapper) GetService(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "group_id" -------------
	var groupId GroupID

	err = runtime.BindStyledParameterWithOptions("simple", "group_id", chi.URLParam(r, "group_id"), &groupId, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "group_id", Err: err})
		return
	}

	// ------------- Path parameter "service_name" -------------
	var serviceName ServiceName

	err = runtime.BindStyledParameterWithOptions("simple", "service_name", chi.URLParam(r, "service_name"), &serviceName, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "service_name", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetService(w, r, groupId, serviceName)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetHealth operation middleware
func (siw *ServerInterfaceWrapper) GetHealth(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetHealth(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Put(options.BaseURL+"/v1/groups/{group_id}/inways/{inway_name}", wrapper.RegisterInway)
	})
	r.Group(func(r chi.Router) {
		r.Put(options.BaseURL+"/v1/groups/{group_id}/outways/{outway_name}", wrapper.RegisterOutway)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/v1/groups/{group_id}/services/{service_name}", wrapper.GetService)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/v1/health", wrapper.GetHealth)
	})

	return r
}

type N400BadRequestApplicationProblemPlusJSONResponse Error

type N401UnauthorizedApplicationProblemPlusJSONResponse Error

type N403ForbiddenApplicationProblemPlusJSONResponse Error

type N404NotFoundApplicationProblemPlusJSONResponse Error

type N408RequestTimeoutApplicationProblemPlusJSONResponse Error

type N413PayloadTooLargeApplicationProblemPlusJSONResponse Error

type N414URITooLongApplicationProblemPlusJSONResponse Error

type N422UnprocessableEntityApplicationProblemPlusJSONResponse Error

type N429TooManyRequestsApplicationProblemPlusJSONResponse Error

type N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse Error

type N500InternalServerErrorApplicationProblemPlusJSONResponse Error

type N503ServiceUnavailableApplicationProblemPlusJSONResponse Error

type N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse Error

type RegisterInwayRequestObject struct {
	GroupId   GroupID `json:"group_id"`
	InwayName string  `json:"inway_name"`
	Body      *RegisterInwayJSONRequestBody
}

type RegisterInwayResponseObject interface {
	VisitRegisterInwayResponse(w http.ResponseWriter) error
}

type RegisterInway204Response struct {
}

func (response RegisterInway204Response) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.WriteHeader(204)
	return nil
}

type RegisterInway400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response RegisterInway400ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response RegisterInway401ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response RegisterInway403ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway404ApplicationProblemPlusJSONResponse struct {
	N404NotFoundApplicationProblemPlusJSONResponse
}

func (response RegisterInway404ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response RegisterInway408ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response RegisterInway413ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response RegisterInway414ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response RegisterInway422ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response RegisterInway429ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response RegisterInway431ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response RegisterInway500ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response RegisterInway503ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type RegisterInway505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response RegisterInway505ApplicationProblemPlusJSONResponse) VisitRegisterInwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutwayRequestObject struct {
	GroupId    GroupID `json:"group_id"`
	OutwayName string  `json:"outway_name"`
	Body       *RegisterOutwayJSONRequestBody
}

type RegisterOutwayResponseObject interface {
	VisitRegisterOutwayResponse(w http.ResponseWriter) error
}

type RegisterOutway204Response struct {
}

func (response RegisterOutway204Response) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.WriteHeader(204)
	return nil
}

type RegisterOutway400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response RegisterOutway400ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response RegisterOutway401ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response RegisterOutway403ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway404ApplicationProblemPlusJSONResponse struct {
	N404NotFoundApplicationProblemPlusJSONResponse
}

func (response RegisterOutway404ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response RegisterOutway408ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response RegisterOutway413ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response RegisterOutway414ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response RegisterOutway422ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response RegisterOutway429ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response RegisterOutway431ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response RegisterOutway500ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response RegisterOutway503ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type RegisterOutway505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response RegisterOutway505ApplicationProblemPlusJSONResponse) VisitRegisterOutwayResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

type GetServiceRequestObject struct {
	GroupId     GroupID     `json:"group_id"`
	ServiceName ServiceName `json:"service_name"`
}

type GetServiceResponseObject interface {
	VisitGetServiceResponse(w http.ResponseWriter) error
}

type GetService200JSONResponse struct {
	Service Service `json:"service"`
}

func (response GetService200JSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetService400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response GetService400ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type GetService401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response GetService401ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type GetService403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response GetService403ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type GetService404ApplicationProblemPlusJSONResponse struct {
	N404NotFoundApplicationProblemPlusJSONResponse
}

func (response GetService404ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type GetService408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response GetService408ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type GetService413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response GetService413ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type GetService414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response GetService414ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type GetService422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response GetService422ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type GetService429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response GetService429ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type GetService431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response GetService431ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type GetService500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response GetService500ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type GetService503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response GetService503ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type GetService505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response GetService505ApplicationProblemPlusJSONResponse) VisitGetServiceResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

type GetHealthRequestObject struct {
}

type GetHealthResponseObject interface {
	VisitGetHealthResponse(w http.ResponseWriter) error
}

type GetHealth200Response struct {
}

func (response GetHealth200Response) VisitGetHealthResponse(w http.ResponseWriter) error {
	w.WriteHeader(200)
	return nil
}

type GetHealth503Response struct {
}

func (response GetHealth503Response) VisitGetHealthResponse(w http.ResponseWriter) error {
	w.WriteHeader(503)
	return nil
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// Register an Inway
	// (PUT /v1/groups/{group_id}/inways/{inway_name})
	RegisterInway(ctx context.Context, request RegisterInwayRequestObject) (RegisterInwayResponseObject, error)
	// Register an Outway
	// (PUT /v1/groups/{group_id}/outways/{outway_name})
	RegisterOutway(ctx context.Context, request RegisterOutwayRequestObject) (RegisterOutwayResponseObject, error)
	// Get a service
	// (GET /v1/groups/{group_id}/services/{service_name})
	GetService(ctx context.Context, request GetServiceRequestObject) (GetServiceResponseObject, error)
	// health endpoint for the Controller Registration API
	// (GET /v1/health)
	GetHealth(ctx context.Context, request GetHealthRequestObject) (GetHealthResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHTTPHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHTTPMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// RegisterInway operation middleware
func (sh *strictHandler) RegisterInway(w http.ResponseWriter, r *http.Request, groupId GroupID, inwayName string) {
	var request RegisterInwayRequestObject

	request.GroupId = groupId
	request.InwayName = inwayName

	var body RegisterInwayJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.RegisterInway(ctx, request.(RegisterInwayRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "RegisterInway")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(RegisterInwayResponseObject); ok {
		if err := validResponse.VisitRegisterInwayResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// RegisterOutway operation middleware
func (sh *strictHandler) RegisterOutway(w http.ResponseWriter, r *http.Request, groupId GroupID, outwayName string) {
	var request RegisterOutwayRequestObject

	request.GroupId = groupId
	request.OutwayName = outwayName

	var body RegisterOutwayJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.RegisterOutway(ctx, request.(RegisterOutwayRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "RegisterOutway")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(RegisterOutwayResponseObject); ok {
		if err := validResponse.VisitRegisterOutwayResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// GetService operation middleware
func (sh *strictHandler) GetService(w http.ResponseWriter, r *http.Request, groupId GroupID, serviceName ServiceName) {
	var request GetServiceRequestObject

	request.GroupId = groupId
	request.ServiceName = serviceName

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetService(ctx, request.(GetServiceRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetService")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetServiceResponseObject); ok {
		if err := validResponse.VisitGetServiceResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// GetHealth operation middleware
func (sh *strictHandler) GetHealth(w http.ResponseWriter, r *http.Request) {
	var request GetHealthRequestObject

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetHealth(ctx, request.(GetHealthRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetHealth")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetHealthResponseObject); ok {
		if err := validResponse.VisitGetHealthResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xaS3PbOBL+K13cPWRqaUmW7TjWLe+oNutN+bGX2OWCiKaIGRLgAKBkjUv/fasBkCIt",
	"2qPMbnTyIVUigEa/P3R3/BAlqiiVRGlNNHmISqZZgRa1+5prVZXTD/STo0m0KK1QMppEn2kDph+iOBL0",
	"XTKbRXEkWYHRxJPdCR7FkcbfK6GRRxOrK4wjk2RYMLrw7xrTaBL9bbgRYOh3zbDmu16v6QpTKmnQSXQ8",
	"Gr1j/AJ/r9BYWkiUtCjdT1aWuUgYiTgstZrlWPzjV0PyPuzIF7VW2nPt6vuOcQhMY3iFg/kghoLlqdIF",
	"ctB+B8xKWnYfgxF/IFilIGd6jjEIuWC52Jwr0Bg2R0g1K4Scx6A0cEywtGKBzSmtKivk/JdBtI6j49Hh",
	"tWSVzZQWf5A596V5m2sMNkOoDGrgCg1IZSFjCwSvHh1EaYMgkGjk9MlyA6nSjtaSQSxoNKrSCQbVjj4p",
	"PROco9yfXg3LJ5Wi5RJ1IYwhdawCvMeksrQjTO0mr8HxubKfVCX36JhzZcGx9AoEcVw0euNCoqqcO31m",
	"CCkdDfZ+E0L5ShSoqj2mUeALgbGXPMkFSgtceFlLrXiVILAmEZbCZkL6+BEFmZ9Z92VQL1DDkhkoNZZM",
	"Iyc3LZmwXtPDo29slSvGr5T6SqG3P1UDY7hSCr56GGi5CYTx4EBpwWRbG2FgKfJcyDnBApvlBCVklQSN",
	"CWodX19MSSUl53tEgoup10YRZJHEtFJqtRAcufOCwzwl502+B50eKzAeX8uwQAp+lFbY1T4xrcUcPPeu",
	"e0iZJeb5QUD4WeXXKlk7xKVUnqslcuCVWzJYMII/cIxrVc+ulPoXk6sQ+2Z/apKziHP9cpkW1GXMgKG0",
	"I5cVdCiobkBIYDAXC5TAClVJCyp1iecVOjoM131BxlF/Ephzs//8qqHESwFejMfZtkmpStZJtYnFjsdn",
	"mLDKIKCwGWpgEoTkYiF4xXLIPJOUmLjXmuW5o25vGEhUnmNCj3i+ioHpVhHgbHcyGk2lRS1Zfukk++i0",
	"25vNaubguYNjH5O3UaKuA7cuT+IQBMuMIkFCJfG+xISemERJLtwjT0mBMqEwQYJfJgnFoVAawZSYiFQk",
	"Tb0jDJhKWEqhYI8jkkQkeC3ZgomcdvZnjsAbWsw7YZMw6YsByXPsBMurOlqEQ3K1QE1gj9xVcmopHQAW",
	"TJAaTCb4ywA+k41ZnjukEYboGFgsSqWZXoGxzNZWOflydfXtP6ip7jhX9rIqS6XtPqs+EgCCBECVRiND",
	"x0JNwWT8tttztItAWxnkEB7vYL1BRPyCCCQh1lnQlcFFJ6jZr5hYYEmiNA/5+/3i03s4Oz45vX2VWVua",
	"yXC4XC4HOk0OkAur9EDp+VCnCf2jc4PMFvkvURyVWpWorfDNBEfLRG62WX+pCiYPNDLu4B7vy5xJX9U2",
	"QW2V96NKkkprlAk6nKSi0fticCOvMoSbwOYmAmO1K/dFSvUKwW8MqppnhMKQqqQyoCRkmJdO0U1tlCit",
	"yQqt22PQzCGVqx/mYkEkHGfVfE6/hKSXy4k8uJFRHNlVSa2ZF4HCTEhjKTS3tadnXWOKXilXbQlXyacC",
	"PWg2Rnha+T6WFONVn7kpYvwmJIqjxyNGSDNbuVuVFnMh67Dz1cWzto/iqGD3oqiKaHJydhZHhZD+63A0",
	"akSj/JyjJtmssHmPLS4zpW0MWTcgTFUUlLRdpkC39iruF37czn9y8brdX3/3u42Va5XiJsxbPr9dx083",
	"9xS1ny7fQ93kw6sPgsJP6RWVfJRHeM+KkuwVpSY5yFXC8v4YW7LVW841mh63h43aiu5w5+46ud3OweEg",
	"7AwSVUyOj4/6OJbVLBfJP3F1lVXFrNTCQ+W2grbZb7zoSOE3XHVQKyG8SAlnqWFXhVv8d2WXbOVePu6P",
	"fsF78CnXUeE0naVpcjoeJ2x89Hp8epryQ87560M2nr0eM5zh6DgZz075m9FoxMYMD1l6dsbZ0elojKM3",
	"hz6Ov6Kc2yyavD7uyyr/jLnpTQfeUPJSCWnvKp33WF/C9cXXWvlwCdQ0W35wbvDlwwErxeTNqM/8zeRn",
	"1wFPiJE7tgmS5+g6AbWuB07P0wTVzuno45RpTarcVY/FibtGvG1U9s9Sy/znQZLtSKOLycysNnLHtppJ",
	"roq7sHUXpGj5fHxy4tCr/j7ahgFnxVRts28KvvdKWk3VqYaLj5dX8Pbb9EbeyPdMUiPjwt0qKuvolAuI",
	"FgXVdEnrJMFvUICoNM6FsegbvimZz1H4FAmPjwfXXnnefptGcRTqhWgSHQ5GgxEZVpUoWSmiSXQ0GA0o",
	"20tmMxciw8WhDyEzfKhduPbBYYYP3oVkybVLiqoHAi6C0FSESVx6ud3L3NIiJ8BfAd4L1zwJ6zpzqErO",
	"LAbMap7ZyEms3e8pb7GYBlxrj1a/94fs5kgrQx6Lfh7iqRG0fwi7scKzY9hNJE49yvY8M7f+AjT2neLP",
	"9enb1WcXkf5Slj9K2fqO7VzsniRFH0+Px6PjviQhZ9dRjNzPyEZPCdlcOOzOov2Qdheq7iTXT0B3oWuN",
	"Sf3QcReizWTSj/52oXk8H/SjtB0ot+dtfly1C2l7puVnRDtQ9Q+S/NxlF/Kt4YyfcOxA+vwYxDf7f37N",
	"ExMB3xvvQt7XQPsechfqJxtN16H5IreFZMBkQBza7wdh5WDfDB/8jx+EYf9oNDgcyqz/ExD7234SEjeX",
	"90BxyxQ7YrG/7eeCsa93737D1Z3tFMvPQXNfff0YofsvfsHrF7x+weu943XApacBO3QeZvjQ7kEcZM+x",
	"F7JtpaXpdI0zRn2BkjCvRwbUAdS7Afe6oPwZ7WXTDv0MQN40Wz2I/Kjd+mt/pdBtLG+3sGv0P4Bzq6nf",
	"QYQtCK7X+0G3dwz+AqMvMPoCo20Y/Yy2NbSpETRDltusBY9buPbFn+jHg27utecyDrT9TfD22xSEAc9r",
	"1TLMD5FXsrmgo5hfbWZ9zf/WP3OdBw4/f/cg7YaKzYj2IWlor3W+DuPZBdOCfNP8p3dzwuuSsiq30SRy",
	"A+RMGRtt/9FBM6LcSEfC3K7/GwAA///R6XfuuyYAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
